package de.joethei.hs.java2.praktikum.praktikum1;

public class GrosseZahl {

    private int Zahl[];

    public GrosseZahl(String d) {
        Boolean korrekteEingabe=true;
        for(int i=0; i<d.length(); i++) {
            if(d.charAt(i) < '0' || d.charAt(i) > '9') {
                korrekteEingabe = false;
            }
        }
        if(korrekteEingabe) {
            Zahl = new int[d.length()];
            for(int w=0; w<d.length(); w++) {
                Zahl[w] = Integer.parseInt(String.valueOf(d.charAt(w)));
            }
        } else {
            System.out.println("Incorrect Input!");
        }
    }

    public GrosseZahl(int i) {
        this(Integer.toString(i));
    }

    @Override
    public String toString() {
        StringBuilder rueckgabe = new StringBuilder();
        for (int aZahl : Zahl) {
            rueckgabe.append(Integer.toString(aZahl));
        }
        return rueckgabe.toString();
    }

    public boolean less(GrosseZahl b) {
        if(this.Zahl.length < b.Zahl.length) return true;
        if(this.Zahl.length > b.Zahl.length) return false;
        //if(this.equals(b)) return false;
        for(int i=0; i<this.Zahl.length; i++) {
            if(this.Zahl[i] > b.Zahl[i]) return false;
            if(this.Zahl[i] < b.Zahl[i]) return true;
        }
        return false;
    }

    public GrosseZahl add(GrosseZahl b) {
        int uebertrag = 0;
        GrosseZahl rueckgabe, operand;
        if(this.less(b)) {
            rueckgabe = new GrosseZahl(b.toString());
            operand = new GrosseZahl(this.toString());
        } else {
            rueckgabe = new GrosseZahl(this.toString());
            operand = new GrosseZahl(b.toString());
        }
        for(int i=(rueckgabe.Zahl.length-1), w=(operand.Zahl.length-1); i>=0; i--, w--) {
            rueckgabe.Zahl[i] += uebertrag;
            uebertrag = 0;
            if(w>=0) {
                rueckgabe.Zahl[i] += operand.Zahl[w];
            }
            if(rueckgabe.Zahl[i] > 9) {
                rueckgabe.Zahl[i] -= 10;
                uebertrag = 1;
            }
            if(i==0 && uebertrag==1) {
                return new GrosseZahl("1"+rueckgabe.toString());
            }
        }
        return rueckgabe;
    }

    public GrosseZahl sub(GrosseZahl b) {
        int uebertrag = 0;
        StringBuilder x;
        if(this.equals(b)) {
            return new GrosseZahl(0);
        } else if(this.less(b)) {
            System.out.println("sub() kann keine negativen Werte zurückgeben.");
            return new GrosseZahl(0);
        }
        GrosseZahl rueckgabe = new GrosseZahl(this.toString());
        GrosseZahl operand = new GrosseZahl(b.toString());
        for(int i=(rueckgabe.Zahl.length-1), w=(operand.Zahl.length-1); i>=0; i--, w--) {
            if(w>=0) {
                rueckgabe.Zahl[i] -= operand.Zahl[w];
            }
            rueckgabe.Zahl[i] -= uebertrag;
            uebertrag = 0;
            if(rueckgabe.Zahl[i] < 0) {
                rueckgabe.Zahl[i] += 10;
                uebertrag += 1;
            }
        }
        while(rueckgabe.Zahl[0] == 0) {
            x = new StringBuilder();
            for(int i=1; i<rueckgabe.Zahl.length; i++) {
                x.append(rueckgabe.Zahl[i]);
            }
            rueckgabe = new GrosseZahl(x.toString());
        }
        return rueckgabe;
    }

    public GrosseZahl mult(GrosseZahl b) {
        GrosseZahl rueckgabe, rueckgabe_b, operand, operand2;
        rueckgabe_b = new GrosseZahl(0);
        if(this.less(b)) {
            operand2 = b;
            operand = this;
        } else {
            operand2 = this;
            operand = b;
        }
        for(int i=0; i<operand.Zahl.length; i++) {
            rueckgabe = new GrosseZahl(0);
            for(int w=0; w<operand.Zahl[i]; w++) {
                rueckgabe = rueckgabe.add(operand2);
            }
            rueckgabe_b = rueckgabe_b.add(rueckgabe);
            if(i != operand.Zahl.length-1) {
                rueckgabe_b = new GrosseZahl(rueckgabe_b.toString()+"0");
            }
        }
        return rueckgabe_b;
    }

    /*
    Boolean equals(GrosseZahl b) {
        if(this.Zahl.length < b.Zahl.length || this.Zahl.length > b.Zahl.length) return false;
        for(int i=0; i<this.Zahl.length; i++) {
            if(this.Zahl[i] != b.Zahl[i]) return false;
        }
        return true;
    }
    */

    public GrosseZahl ggT(GrosseZahl b) {
        GrosseZahl operand1 = new GrosseZahl(this.toString());
        GrosseZahl operand2 = new GrosseZahl(b.toString());
        if(operand1.equals(operand2)) return operand1;
        else if(operand1.less(operand2)) return operand1.ggT(operand2.sub(operand1));
        else return operand1.sub(operand2).ggT(operand2);
    }

    @Override
    public boolean equals(Object o) {
        if(o instanceof GrosseZahl) {
            GrosseZahl tmp = (GrosseZahl) o;
            if(tmp.Zahl.length == this.Zahl.length) {
                for(int i = this.Zahl.length - 1; i >= 0; i--) {
                    if(tmp.Zahl[i] != this.Zahl[i]) return false;
                }
                return true;
            }else return false;
        }
        return false;
    }

}
